import plistlib
import os.path

def append2list(srcDict, desList, prefix, beginIndex, endIndex) :
	for suffix in range(beginIndex, endIndex, 1):
		key = prefix + str(suffix)
		if srcDict.has_key(key) == True:
			value = srcDict[key]
			try:
				desList.index(value)
			except:
				desList.append(value)
		else:
			break

def migrateTmccmac() :
	TMP_CONF_DIR="/var/tmp/TrendMicro/conf/"
	TMCCMAC_PLIST=TMP_CONF_DIR + "tmccmac.conf.plist"
	if os.path.exists(TMCCMAC_PLIST) == False:
		return
	tmccmacPL = plistlib.readPlist(TMCCMAC_PLIST)

	TM_CONF_DIR="/Library/Application Support/TrendMicro/common/conf/"
	TM_ANTIMALWARE_PLIST=TM_CONF_DIR + "TmAntiMalware.conf.plist"
	TM_UPDATE_PLIST=TM_CONF_DIR + "TmUpdate.conf.plist"
	TM_PROXYEX_PLIST=TM_CONF_DIR + "wp/TmProxyExt.conf.plist"
	antimalwarePL = plistlib.readPlist(TM_ANTIMALWARE_PLIST)
	updatePL = plistlib.readPlist(TM_UPDATE_PLIST)
	proxyexPL = plistlib.readPlist(TM_PROXYEX_PLIST)

	antimalwarePL["RealtimeScan"]["compression_layer"] = int(tmccmacPL["SCAN"]["RealtimeScanLayer"])
	antimalwarePL["RealtimeScan"]["remote_disk_unhook_type"] = int(tmccmacPL["SCAN"]["RemoteDiskUnhookType"])
	antimalwarePL["ScheduleScan"]["alert_count_down"] = int(tmccmacPL["SCAN"]["ScheduleAlertCountDown"])
	
	if antimalwarePL["RealtimeScan"].has_key("remote_disk_unhook_fs") == False:
		antimalwarePL["RealtimeScan"]["remote_disk_unhook_fs"] = []
	antimalwarePL["RealtimeScan"]["remote_disk_unhook_fs"] = list( set(antimalwarePL["RealtimeScan"]["remote_disk_unhook_fs"]) | set(tmccmacPL["SCAN"]["RemoteDiskUnhookFsType"].split()) )
	
	if antimalwarePL["RealtimeScan"].has_key("exception_processes") == False:
		antimalwarePL["RealtimeScan"]["exception_processes"] = []
	append2list(tmccmacPL["SCAN"], antimalwarePL["RealtimeScan"]["exception_processes"], "EXCPROCESS", 1, 1000)

	updatePL["SourceInfo"]["source"] = tmccmacPL["SOURCEINFO"]["Source"]
	updatePL["SourceInfo"]["use_sys_proxy"] = False

	proxyexPL["WtpOptions"]["enable_black_list"] = bool(tmccmacPL["URLFilter"]["EnableBlack"])
	proxyexPL["WtpOptions"]["enable_white_list"] = bool(tmccmacPL["URLFilter"]["EnableWhite"])
	if proxyexPL["WhiteList"].has_key("url_list") == False:
		proxyexPL["WhiteList"]["url_list"] = []
	append2list(tmccmacPL["URLFilterWhiteList"], proxyexPL["WhiteList"]["url_list"], "", 0, 1000)

	plistlib.writePlist(antimalwarePL, TM_ANTIMALWARE_PLIST)
	plistlib.writePlist(updatePL, TM_UPDATE_PLIST)
	plistlib.writePlist(proxyexPL, TM_PROXYEX_PLIST)

def migrateTmcccore() :
	TMP_CONF_DIR="/var/tmp/TrendMicro/conf/"
	TMCCCORE_PLIST=TMP_CONF_DIR + "tmcccore.conf.plist"
	if os.path.exists(TMCCCORE_PLIST) == False:
		return
	tmcccorePL = plistlib.readPlist(TMCCCORE_PLIST)

	TM_CONF_DIR="/Library/Application Support/TrendMicro/common/conf/"
	TM_PROXYINT_PLIST=TM_CONF_DIR + "wp/TmProxyInt.conf.plist"
	proxyintPL = plistlib.readPlist(TM_PROXYINT_PLIST)

	if proxyintPL["ExceptionRule"].has_key("rules") == False:
		proxyintPL["ExceptionRule"]["rules"] = []
	append2list(tmcccorePL["ExceptionRule"], proxyintPL["ExceptionRule"]["rules"], "", 0, 1000)

	plistlib.writePlist(proxyintPL, TM_PROXYINT_PLIST)

def mergeConfig(old_config, new_config, output_config):
	old_pl = plistlib.readPlist(os.path.abspath(old_config))
	final_pl = old_pl
	try:
		new_pl = plistlib.readPlist(os.path.abspath(new_config))
		final_pl = mergeOption(old_pl, new_pl)
	except IOError:
		print "Migrate Config: Can't read old plist file"
	
	try:
		plistlib.writePlist(final_pl, output_config)
	except IOError:
		print "Migrate Config: Write configuration failure"

# use new_option except new_option is an list
def mergeOption(old_option, new_option):
	if type(old_option) is not type(new_option):
		return new_option
	
	if type(old_option).__name__ == '_InternalDict' or type(old_option).__name__ == 'dict':
		for key in old_option:
			value = old_option[key]
			if new_option.has_key(key):
				value = mergeOption(old_option[key], new_option[key])
			new_option[key] = value
	elif type(old_option).__name__ == 'list':
		new_option = mergeList(old_option, new_option)
	
	return new_option

def mergeList(old_list, new_list):
	for element in old_list:
		# perform merge only when it's a list of value, not a list of array or dict
		if type(element).__name__ == '_InternalDict' or type(element).__name__ == 'dict' or type(element).__name__ == 'list':
			break
		if element not in new_list:
			new_list.append(element)
	return new_list

# Merge icore 1.5 settings into icore 2.0 	
migrateTmccmac()
migrateTmcccore()

# Merge icore 2.0 settings into icore 2.0, Only merge the pilst which exist in installation package
conf_config_dir = ["/var/tmp/TrendMicro/conf/", "/Library/Application Support/TrendMicro/common/conf/"]
conf_config_list = ["TmAntiMalware.conf.plist", "TmUpdate.conf.plist", "TMCNTMgmt.config.plist", "TMCNTMgmt.scheduler.plist"]
wp_config_dir = ["/var/tmp/TrendMicro/conf/wp/", "/Library/Application Support/TrendMicro/common/conf/wp/"]
wp_config_list = ["TmProxyExt.conf.plist", "TmProxyInt.conf.plist"]

for config_path in conf_config_list:
	old_config_path = conf_config_dir[0] + config_path
	new_config_path = conf_config_dir[1] + config_path
	mergeConfig(old_config_path, new_config_path, new_config_path)

for config_path in wp_config_list:
	old_config_path = wp_config_dir[0] + config_path
	new_config_path = wp_config_dir[1] + config_path
	mergeConfig(old_config_path, new_config_path, new_config_path)
